// --------------------------------------------------------
// Copyright (c)
//
// contributions by author
//                  author@somewhere.net
// maintained by    CEA LIST
//                  info-list@cea.fr

// --------------------------------------------------------
// Code generated by Papyrus C++
// --------------------------------------------------------

#define periodicPublisherCompdef_PeriodicPublisher_BODY

/************************************************************
 PeriodicPublisher class body
 ************************************************************/

// include associated header file
#include "periodicPublisherCompdef/PeriodicPublisher.h"

// Derived includes directives
#include "periodicPublisherCompdef/PeriodicPublisher_main.h"
#include "rclcpp/rclcpp.hpp"

namespace periodicPublisherCompdef {

// static attributes (if any)

/**
 * 
 */
void PeriodicPublisher::fPublishing() {
  simple_msgs::msg::Map map;
  map.ogm.width = 16;
  map.ogm.height = 16;
  map.ogm.resolution = 0.1;

  RCLCPP_INFO(get_logger(), "now publishing");

  pMap_pub_->publish(map);

}

/**
 * 
 * @param options 
 */
PeriodicPublisher::PeriodicPublisher(rclcpp::NodeOptions /*in*/options) :
    rclcpp_lifecycle::LifecycleNode("PeriodicPublisher", options) {
  cbg_Activity1_ = create_callback_group(
      rclcpp::CallbackGroupType::MutuallyExclusive);
  cbg_t_Activity1_ = create_callback_group(
      rclcpp::CallbackGroupType::MutuallyExclusive);

  rclcpp::PublisherOptions pMap_options;
  pMap_options.callback_group = cbg_Activity1_;
  pMap_pub_ = create_publisher < simple_msgs::msg::Map
      > ("pMap", 1, pMap_options);
  // directly activate a publisher
  pMap_pub_->on_activate();

}

/**
 * 
 */
void PeriodicPublisher::declareParameters() {
  declare_parameter("indoor", rclcpp::ParameterValue(true));
  declare_parameter("noOfScans", rclcpp::ParameterValue(5));
}

/**
 * 
 */
void PeriodicPublisher::initParameterVars() {
  get_parameter("indoor", indoor_);
  get_parameter("noOfScans", noOfScans_);
}

} // of namespace periodicPublisherCompdef

/************************************************************
 End of PeriodicPublisher class body
 ************************************************************/
